var u = Object.defineProperty;
var f = (r, t, e) => t in r ? u(r, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : r[t] = e;
var a = (r, t, e) => f(r, typeof t != "symbol" ? t + "" : t, e);
const i = class i {
  constructor(t = {}) {
    a(this, "options");
    a(this, "highlights");
    this.options = {
      backgroundColor: t.backgroundColor || "yellow",
      textColor: t.textColor || "inherit",
      fontWeight: t.fontWeight || "inherit",
      fontStyle: t.fontStyle || "inherit",
      customClass: t.customClass || ""
    }, this.highlights = /* @__PURE__ */ new Map();
  }
  static getInstance(t) {
    return i.instance || (i.instance = new i(t)), i.instance;
  }
  highlightSelectedText() {
    const t = window.getSelection();
    if (!t || t.rangeCount === 0) return;
    const e = t.getRangeAt(0), n = e.startContainer.parentElement, s = e.endContainer.parentElement;
    if (n !== s) {
      console.log(
        "Cannot highlight across multiple lines. Highlighting aborted."
      );
      return;
    }
    const g = e.toString().trim();
    if (!g) return;
    const m = Array.from(
      e.commonAncestorContainer.childNodes
    ).some((l) => {
      if (l.nodeType === Node.ELEMENT_NODE) {
        const h = l;
        return ["INPUT", "TEXTAREA", "SELECT", "BUTTON"].includes(
          h.tagName
        );
      }
      return !1;
    }), o = document.createElement("span");
    if (o.style.backgroundColor = this.options.backgroundColor, o.style.color = this.options.textColor, o.style.fontWeight = this.options.fontWeight, o.style.fontStyle = this.options.fontStyle, o.className = this.options.customClass, m) {
      const l = e.cloneContents(), h = document.createDocumentFragment();
      h.appendChild(l), o.appendChild(h);
    } else
      o.textContent = g;
    e.deleteContents(), e.insertNode(o);
    const c = `highlight-${Date.now()}`;
    this.highlights.set(c, {
      id: c,
      text: g,
      range: e.cloneRange()
    }), t.removeAllRanges();
  }
  removeHighlights() {
    this.highlights.forEach((t) => {
      const n = t.range.startContainer.parentElement;
      n && n.replaceWith(n.innerText);
    }), this.highlights.clear();
  }
  addAnnotationToHighlight(t, e) {
    const n = this.highlights.get(t);
    n && (n.annotation = e);
  }
  addHighlightListener(t) {
    const e = document.getElementById(t);
    e && e.addEventListener(
      "mouseup",
      this.highlightSelectedText.bind(this)
    );
  }
  removeHighlightListener(t) {
    const e = document.getElementById(t);
    e && e.removeEventListener(
      "mouseup",
      this.highlightSelectedText.bind(this)
    );
  }
  getHighlights() {
    return Array.from(this.highlights.values());
  }
  saveHighlights() {
    const t = Array.from(this.highlights.values());
    localStorage.setItem("highlights", JSON.stringify(t));
  }
  loadHighlights() {
    JSON.parse(
      localStorage.getItem("highlights") || "[]"
    ).forEach((e) => {
      this.highlights.set(e.id, e);
      const n = document.createRange();
      n.setStart(
        e.range.startContainer,
        e.range.startOffset
      ), n.setEnd(
        e.range.endContainer,
        e.range.endOffset
      );
      const s = document.createElement("span");
      s.style.backgroundColor = this.options.backgroundColor, s.style.color = this.options.textColor, s.style.fontWeight = this.options.fontWeight, s.style.fontStyle = this.options.fontStyle, s.className = this.options.customClass, s.textContent = e.text, n.deleteContents(), n.insertNode(s);
    });
  }
};
a(i, "instance", null);
let d = i;
export {
  d as default
};
